using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Drawing;

namespace XSOC_Gui
{
    class Register
    {
        private TextBox regTextBox;
        private UInt16 regValue;
        private string regRadix;
        
        public Register()
        {
            regTextBox = new TextBox();
            regValue = 0;
            regRadix = "Hexadecimal";
            //cf.ConsoleWriteLine("Register()---- RegText = " + regText.ToString());
        }

        
        public TextBox RegTextBox
        {
            get
            {
                return regTextBox;
            }
            set
            {
                regTextBox = value;
            }
        }

        public UInt16 RegValue
        {
            get
            {
                return regValue;
            }
            set
            {
                regValue = value;
                applyRadix();
            }
        }
        public string RegRadix
        {
            get
            {
                return regRadix;
            }
            set
            {
                regRadix = value;
                applyRadix();
            }
        }

        private void applyRadix(){
            if (regRadix.Equals("Hexadecimal"))
                {
                    regTextBox.Text = regValue.ToString("X04");
                    regTextBox.MaxLength = 4;
                    regTextBox.BackColor = Color.White;

                }
                else if (regRadix.Equals("Unsigned Decimal"))
                {
                    regTextBox.Text = regValue.ToString();
                    regTextBox.MaxLength = 5;
                    regTextBox.BackColor = Color.Moccasin;
                }
                else if (regRadix.Equals("Signed Decimal"))
                {
                    regTextBox.Text = ((Int16)regValue).ToString();
                    regTextBox.MaxLength = 6;
                    regTextBox.BackColor = Color.PaleTurquoise;
                }
        }


        public override string ToString()
        {
            return(" Text:" + regTextBox.Text + " Value(hex): " +regValue.ToString("X04") + " " + regRadix);
        }
        public bool TryParseRegTextBox()
        {
            UInt16 readValU16;
            Int16 readValI16;
            bool result=false;
            if (regRadix.Equals("Hexadecimal"))
            {
                result = UInt16.TryParse(regTextBox.Text, NumberStyles.HexNumber, null, out readValU16);
                if (result)
                    regValue = readValU16;
                else if (regTextBox.Text.Length == 0 )
                    regValue = 0;
                regTextBox.Text = regValue.ToString("X04");
            }
            else if (regRadix.Equals("Unsigned Decimal"))
            {
                result = UInt16.TryParse(regTextBox.Text, NumberStyles.Integer, null, out readValU16);
                if (result)
                    regValue = readValU16;
                else if (regTextBox.Text.Length == 0)
                    regValue = 0;
                
                regTextBox.Text = regValue.ToString();
            }
            else if (regRadix.Equals("Signed Decimal"))
            {
                result =Int16.TryParse(regTextBox.Text, NumberStyles.Integer, null, out readValI16); 
                if (result)
                    regValue = (UInt16)readValI16;
                else if (regTextBox.Text.Length == 0)
                    regValue = 0;
                
                regTextBox.Text = ((Int16)regValue).ToString();

            }

            return result;
        }
    }
}
