;
; CRT1.s -- xr16 C runtime library startup
; Created by: Peter Czako
;
; This file must be assembled first, so that reset and interrupt receive
; the correct addresses:
; 0000 reset vector
; 0010 interrupt vector;
; 
; Info:
;
; - SP initialized to 0x0FFE
; - 1 Interrupt
;

global _main
global _isr

align 16
reset:   
   lea sp,0x0ffe
   j _main

align 16
interrupt:
   ; save registers
   sw r1,saveregs
   lea r1,saveregs
   sw r2,2(r1)
   sw r3,4(r1)
   sw r4,6(r1)
   sw r5,8(r1)
   sw r6,10(r1)
   sw r7,12(r1)
   sw r8,14(r1)
   sw r9,16(r1)
   sw r10,18(r1)
   sw r11,20(r1)
   sw r12,22(r1)
   sw r13,24(r1)
   sw r14,26(r1)   ; r14 is the (reserved) interrupt return address
   sw r15,28(r1)
   
   call _isr

   ; reload registers
   lea r1,saveregs
   lw r2,2(r1)
   lw r3,4(r1)
   lw r4,6(r1)
   lw r5,8(r1)
   lw r6,10(r1)
   lw r7,12(r1)
   lw r8,14(r1)
   lw r9,16(r1)
   lw r10,18(r1)
   lw r11,20(r1)
   lw r12,22(r1)
   lw r13,24(r1)
   lw r14,26(r1) ; r14 is the (reserved) interrupt return address
   lw r15,28(r1) 
   lw r1,saveregs

   ; return from interrupt
   reti

saveregs:
   bss 30


align 16
_isr:
   ret
