#include "xsoc.h"

char reaction_test_start = 0;
unsigned random_idx = 0;
unsigned random[8] = {561,1086,1533,2267,256,2002,1321,2166};
unsigned reaction_time=0;
char quit = 0;

void wait_ms(unsigned ms){
	unsigned i,j;
	for(i=0;i<ms;i++){
		for(j=0;j<=1999;j++){}	
	}
}
/*BTN 0*/
void isr1(){
	reaction_test_start = 1;
	reaction_time = 0;
	LED = 0;
	SEGM_SEL = 0;
	SEGM_HEX = 0;
	uart_print("Started\r\n");
}
/*BTN 1*/	
void isr2(){
	quit = 1;
	}
/*BTN 2*/	
void isr3(){
	TIMER_CTRL = 0x09;	/* /1 clear on compare */
	SEGM_HEX = reaction_time;		
	reaction_test_start = 0;
	reaction_time = 0;
	uart_print("Stopped\r\n");
	}
/*Timer*/	
void isr4(){
	reaction_time++;
}


void timer_test(){
    char reaction_test_start_old = 0;
	quit = 0;
	uart_print("*** TIMER TEST ***\r\n");
	uart_print("BTN0 - Start measuring\r\n");
	uart_print("    Watch the LEDs\r\n");
	uart_print("BTN2 - Stop measuring\r\n");
	uart_print("Result diplayed in ms\r\n\n");
    uart_print("\r\nPress BTN1 to quit\r\n");
	
	ITC_EN = 0x1f; /* BTN0-2,Timer and isr0 enabled */
	
	
	while(!quit){
		
		if ((reaction_test_start != reaction_test_start_old) &&
				reaction_test_start == 1 ) {
			wait_ms(random[random_idx]);
			LED = 0xFF;
			TIMER_CNT = 0;
			TIMER_MATCH = 12;	/* 1 us per tick */
			TIMER_CTRL = 0x19;	/* /1 clear on compare */
			
			if (random_idx < 7)
	  			random_idx++;
			else
	 			random_idx = 0;
		}
		reaction_test_start_old = reaction_test_start;
	}
	uart_print("Test passed!!!\r\n");
}

void io_test(){
	unsigned int c=0,tmp=0,cnt=0;
	char display = 0xFE;
	char blank = 1;
	
	uart_print("*** IO TEST ***\r\n");
	uart_print("Adjust the switches and the LEDs\r\n");
	uart_print("will display the actual setting.\r\n");
	uart_print("\r\nPress BTN1 to quit\r\n");
	
	quit = 0;
	LED = 0;
	ITC_EN = 0x05; /* BTN1 and isr0 enabled */
	SEGM_SEL = 1;
	SEGM_AN0 = SEGM_AN1 = SEGM_AN2 = SEGM_AN3 = 0xFF;
    
	while(!quit){
		tmp = c;
		c = (int) SWITCH;
		if (c != tmp){
			LED = (char)c;
		}
		
		if (cnt > 30){
			if(blank)
				SEGM_AN0 = SEGM_AN1 = SEGM_AN2 = SEGM_AN3 = display;	
			else
				SEGM_AN0 = SEGM_AN1 = SEGM_AN2 = SEGM_AN3 = ~display;	
			display <<= 1;
			
			if (blank)
				display |= 1;
					
			if (display == 0xFF)
				blank = 0;
			if (display == 0)
				blank = 1;
			cnt = 0;
		}
		wait_ms(10);
		cnt++;
	}
	uart_print("Test passed!!!\r\n");
}


void sram_test(){}


void calculator(){}


int main(){
	char ch;
	int menu_quit=0, really_quit=0;

	uart_print("*******************************\r\n");
	uart_print("\r\n");
	uart_print("__  __   ___    __     __\r\n");
	uart_print("\\ \\/ /  /  _|  /  \\   / _|\r\n");
	uart_print(" \\  /   \\ \\   | || | | /\r\n");
	uart_print(" /  \\   _\\ \\  | || | | \\_\r\n");
	uart_print("/_/\\_\\ /___/   \\__/   \\__|\r\n");
	uart_print("\r\n");
	uart_print("*******************************\r\n");
	uart_print("\r\n");
	uart_print("Welcome to XSOC Software debugger DEMO\r\n");
	uart_print("\r\n");
	uart_print("Press X to continue\r\n\r\n");

	while(!really_quit){
		ch = uart_getc();
		if (ch == 'x' || ch == 'X'){
			uart_print("Chose DEMO to start (0...3)\r\n");
			uart_print("0 - IO test\r\n");
			uart_print("1 - SRAM test\r\n");
			uart_print("2 - Timer test\r\n");
			uart_print("3 - Calculator\r\n");
			uart_print("q - Quit\r\n");
			while(!menu_quit) {
				ch = uart_getc();
				switch(ch){
					case '0' : io_test();break;
					case '1' : sram_test();break;
					case '2' : timer_test();break;
					case '3' : calculator();break;
					case 'Q' : case'q': menu_quit = 1;break; 
				}
			}
			uart_print("Really want to quit? (y/n) \r\n");
			ch = uart_getc();
			if (ch == 'y')
				really_quit = 1;
			else
				menu_quit = 0;

		}
	}
	return 0;
} 

