`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company:         BME-VIK
// Engineer:        Peter Czako
// 
// Create Date:     22:47:46 04/08/2007
// Design Name: 
// Module Name:     esc_detector 
// Project Name:    XSOC
// Target Devices:  SPARTAN-3, SPARTAN-3E
// Tool versions:   XILINX ISE 8.2
// Description:     Extension logic to the kcuart_rx module. Signals if the 
//                  received charachter is ESC (0x1b)
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

//=========================================================
// MODULE DECLARATION
//=========================================================

module esc_detector(
    input   [7:0]   data_received,
    input           data_rdy,
    output          esc_catched
    );

    assign esc_catched = data_rdy & (data_received == 8'h1B);// ESC ascii code
        
endmodule
